﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;

namespace PLINQtrying
{
    // http://www.dotnetperls.com/asparallel
    class Program
    {
        static int SumDefault(IEnumerable<int> array) { return array.Sum(); }

        static int SumAsParallel(IEnumerable<int> array) { return array.AsParallel().Sum(); }

        static void Main()
        {
            int[] array = Enumerable.Range(0, short.MaxValue).ToArray();

            Console.WriteLine(SumAsParallel(array));
            Console.WriteLine(SumDefault(array));

            const int m = 10000;
            var s1 = Stopwatch.StartNew();
            for (int i = 0; i < m; i++)
            {
                SumDefault(array);
            }
            s1.Stop();
            var s2 = Stopwatch.StartNew();
            for (int i = 0; i < m; i++)
            {
                SumAsParallel(array);
            }
            s2.Stop();
            //Console.WriteLine(((double)(s1.Elapsed.TotalMilliseconds * 1000000) /
            //    m).ToString("0.00 ns"));
            //Console.WriteLine(((double)(s2.Elapsed.TotalMilliseconds * 1000000) /
            //    m).ToString("0.00 ns"));
            Console.WriteLine(s1.Elapsed);
            Console.WriteLine(s2.Elapsed);
            //Console.Read();
        }
    }
}
